Subject: [PATCH] clk: debug clock tree

From: [email-masked] (Stephen Warren)
Date: Thu, 13 Dec 2012 11:01:31 -0700

On 12/13/2012 09:27 AM, Mike Turquette wrote:
> On Wed, Dec 12, 2012 at 7:49 PM, Prashant Gaikwad <[email-masked]> wrote:
>> Adds debug file "clock_tree" in /sys/kernel/debug/clk dir.
>> It helps to view all the clock registered in tree format.
>>
> 
> Prashant,
> 
> Thanks for submitting this.  We've been talking about having a single
> file for representing the tree for some time.
> 
> Regarding the output format had you considered using a well known
> format which can be parsed using well known parsing libs?  This avoids
> needing a custom parser just for this one file.  JSON springs to mind
> as something lightweight and well-understood.

One advantage of the format below is that it's very easily
human-readable, and it's not too hard to parse (although I guess you'd
have to parse the indent level to get parent/child relation, which would
suck a bit). Is there room to provide both? Otherwise, I guess the
kernel could include a script to convert from JSON/whatever into the
format below.

>> For example:
>>    clock                        enable_cnt  prepare_cnt  rate
>> ---------------------------------------------------------------------
>>  i2s0_sync                      0           0            24000000
>>  spdif_in_sync                  0           0            24000000
>>     spdif_mux                   0           0            24000000
>>        spdif                    0           0            24000000
>>           spdif_doubler         0           0            48000000
>>              spdif_div          0           0            48000000
>>                 spdif_2x        0           0            48000000